cd /Users/jshim2/Dropbox/projects/passive_portfolio/replication_data


*******************************************************************
* Stock-Fund-Quarter Regressions
*******************************************************************
foreach passive in "active" "passive" {
	*foreach dsharesvar in "dshares_alt" "dshares" "dshares_alt2"{
	foreach dsharesvar in "dshares_alt"{
		foreach bench in "tr" {

			use `passive'_sfq_regdata, clear

			* Table 6/7, SFQ regressions (active/passive)
			local a=1
			foreach v of varlist f1_4facalphabpsq f1_qretbenchadjbps {
				reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
							actshare vwlannturn [aw=wtfund_cf], ///
				 		 noa vce(cluster yq permno fundno)
				if `a' == 1 {
					outreg2 using _regs/sfqreg_`passive', replace bdec(3)
					local a=2
				}
				else{
					outreg2 using _regs/sfqreg_`passive', append bdec(3)
				}
				reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
							actshare vwlannturn [aw=wtfund_cf], ///
				 		 	absorb(fundno yq) vce(cluster yq permno fundno)
				outreg2 using _regs/sfqreg_`passive', append bdec(3)
				reghdfe `v' rebalinadja rebalinadjd ///
							rebalouta rebaloutd [aw=wtfund_cf], ///
				 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
				outreg2 using _regs/sfqreg_`passive', append bdec(3)
			}
		}
	}	
}


*******************************************************************
* Other SFQ Regressions										 
*******************************************************************
use active_sfq_regdata, clear

* Table 9, SFQ regressions with Positive Flow
local a=1
foreach v of varlist f1_4facalphabpsq f1_qretbenchadjbps {
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf] if flowp > 0, ///
	 		 noa vce(cluster yq permno fundno)
	if `a' == 1 {
		outreg2 using _regs/sfqreg_active_posflow, replace bdec(3)
		local a=2
	}
	else{
		outreg2 using _regs/sfqreg_active_posflow, append bdec(3)
	}
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf] if flowp > 0, ///
	 		 	absorb(fundno yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_posflow, append bdec(3)
	reghdfe `v' rebalinadja rebalinadjd ///
				rebalouta rebaloutd [aw=wtfund_cf] if flowp > 0, ///
	 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_posflow, append bdec(3)
}

* Table 9, SFQ regressions with Negative Flow
local a=1
foreach v of varlist f1_4facalphabpsq f1_qretbenchadjbps {
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf] if flowp < 0, ///
	 		 noa vce(cluster yq permno fundno)
	if `a' == 1 {
		outreg2 using _regs/sfqreg_active_negflow, replace bdec(3)
		local a=2
	}
	else{
		outreg2 using _regs/sfqreg_active_negflow, append bdec(3)
	}
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf] if flowp < 0, ///
	 		 	absorb(fundno yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_negflow, append bdec(3)
	reghdfe `v' rebalinadja rebalinadjd ///
				rebalouta rebaloutd [aw=wtfund_cf] if flowp < 0, ///
	 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_negflow, append bdec(3)
}

* Table 8, SFQ regressions with rebalscale
local a=1
foreach v of varlist f1_4facalphabpsq f1_qretbenchadjbps {
	reghdfe `v' rebalscalea rebalscaled ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 noa vce(cluster yq permno fundno)
	if `a' == 1 {
		outreg2 using _regs/sfqreg_active_rebalscale, replace bdec(3)
		local a=2
	}
	else{
		outreg2 using _regs/sfqreg_active_rebalscale, append bdec(3)
	}
	reghdfe `v' rebalscalea rebalscaled ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 	absorb(fundno yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_rebalscale, append bdec(3)
	reghdfe `v' rebalscalea rebalscaled [aw=wtfund_cf], ///
	 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_rebalscale, append bdec(3)
}


* Integrate SUE
preserve
merge m:1 permno yq using regdata_earningsdata_f1
keep if _merge == 3
drop _merge

foreach var of varlist sue7w1 idiosue7w1 {
	drop if `var' == .
	replace `var' = `var' * 100
}

capture drop obs
bysort fundno yq: gen obs=_N
drop if obs==1
drop obs

gen wt_cf = shares * abs(adjprc)
replace wt_cf = lsharesvar * abs(adjprc) if dropvar == 1
bysort fundno yq: egen wttot = total(wt_cf)
replace wtfund_cf = wt_cf / wttot
drop wt_cf wttot

* Table 12, SFQ regressions with SUE 				 
local a=1
foreach v of varlist sue7w1 idiosue7w1 {
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 noa vce(cluster yq permno fundno)
	if `a' == 1 {
		outreg2 using _regs/sfqreg_active_sue, replace bdec(3)
		local a=2
	}
	else{
		outreg2 using _regs/sfqreg_active_sue, append bdec(3)
	}
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 	absorb(fundno yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_sue, append bdec(3)
	reghdfe `v' rebalinadja rebalinadjd ///
				rebalouta rebaloutd [aw=wtfund_cf], ///
	 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_sue, append bdec(3)
}
restore


*******************************************************************
* Longer Horizon Returns										 
*******************************************************************
foreach passive in "active" "passive" {
	foreach bench in "tr" {
		use `passive'_sfq_regdata, clear

		gen f2_4facalphabpsq = f2_4facalphabps * 63
		gen f3_4facalphabpsq = f3_4facalphabps * 63
		gen f4_4facalphabpsq = f4_4facalphabps * 63

		if "`bench'" == "tr" {
			gen f2_qretbenchadj = f2qret - tr
			gen f3_qretbenchadj = f3qret - tr
			gen f4_qretbenchadj = f4qret - tr
		}
		else {
			gen f2_qretbenchadj = f2qret - r
			gen f3_qretbenchadj = f3qret - r
			gen f4_qretbenchadj = f4qret - r
		}

		gen f2_qretbenchadjbps = f2_qretbenchadj*10000
		gen f3_qretbenchadjbps = f3_qretbenchadj*10000
		gen f4_qretbenchadjbps = f4_qretbenchadj*10000

		foreach lead in 1 2 3 4 {
			drop if f`lead'_qretbenchadjbps == .
			drop if f`lead'_4facalphabpsq == .
		}

		capture drop obs
		bysort fundno yq: gen obs=_N
		drop if obs==1
		drop obs

		gen wt_cf = shares * abs(adjprc)
		replace wt_cf = lsharesvar * abs(adjprc) if dropvar == 1
		bysort fundno yq: egen wttot = total(wt_cf)
		replace wtfund_cf = wt_cf / wttot
		drop wt_cf wttot

		* Table 26/27, SFQ regressions over Longer Horizons (Active/Passive)
		foreach lead in 1 2 3 4 {
			local a=1
			foreach v of varlist f`lead'_4facalphabpsq f`lead'_qretbenchadjbps {
				reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
							actshare vwlannturn [aw=wtfund_cf], ///
				 		 noa vce(cluster yq permno fundno)
				if `a' == 1 {
					outreg2 using _regs/sfqreg_`passive'_horizon_q`lead', replace bdec(3)
					local a=2
				}
				else{
					outreg2 using _regs/sfqreg_`passive'_horizon_q`lead', append bdec(3)
				}
				reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
							actshare vwlannturn [aw=wtfund_cf], ///
				 		 	absorb(fundno yq) vce(cluster yq permno fundno)
				outreg2 using _regs/sfqreg_`passive'_horizon_q`lead', append bdec(3)
				reghdfe `v' rebalinadja rebalinadjd ///
							rebalouta rebaloutd [aw=wtfund_cf], ///
				 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
				outreg2 using _regs/sfqreg_`passive'_horizon_q`lead', append bdec(3)
			}
		}
	}	
}



*******************************************************************
* Interact Rebal In measures with no-change-in-shares indicator
*******************************************************************
use active_sfq_regdata, clear

gen nochg = 0
replace nochg = 1 if dshares == 0

gen rebalinadja_x_nochg = nochg * rebalinadja
gen rebalinadjd_x_nochg = nochg * rebalinadjd

* Table 16, SFQ regressions with inactivity indicator
local a=1
foreach v of varlist f1_4facalphabpsq f1_qretbenchadjbps {
	reghdfe `v' rebalinadja rebalinadjd *_x_nochg rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 noa vce(cluster yq permno fundno)
	if `a' == 1 {
		outreg2 using _regs/sfqreg_active_extension_nochg, replace bdec(3)
		local a=2
	}
	else{
		outreg2 using _regs/sfqreg_active_extension_nochg, append bdec(3)
	}
	reghdfe `v' rebalinadja rebalinadjd *_x_nochg rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 	absorb(fundno yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_extension_nochg, append bdec(3)
	reghdfe `v' rebalinadja rebalinadjd *_x_nochg ///
				rebalouta rebaloutd [aw=wtfund_cf], ///
	 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_active_extension_nochg, append bdec(3)
}


*******************************************************************
* Check Alpha Bias due to Delistings
*******************************************************************
use active_sfq_regdata, clear
keep permno yq 
duplicates drop
save temp_permnoyq, replace

use ../data/alphas_betas_small,clear
merge m:1 yq using ../data/tmmkt
drop if _merge==2
drop _merge
replace qret = qret - 1
gen qretmadj=qret-cret_mkt
keep permno yq _1facalpha _3facalpha _4facalpha _4facb* qret dl qretmadj
xtset permno yq
forvalues j=1/4{
	foreach v of varlist _4facalpha {
		gen f`j'`v'=F`j'.`v'
		/* winsor2 f`j'`v', cuts(1 99) replace */
		gen af`j'`v'= ((f`j'`v' + 1)^252-1) * 100
		/* winsor2 af`j'`v', cuts(1 99) replace */
	}
	foreach v of varlist qret qretmadj {
		gen f`j'`v'=F`j'.`v'
		/* winsor2 f`j'`v', cuts(1 99) replace */
		gen af`j'`v'= ((f`j'`v' + 1)^4-1) * 100
		/* winsor2 af`j'`v', cuts(1 99) replace */
	}
}
merge 1:1 permno yq using temp_permnoyq
rename _merge _merge_sample
merge 1:1 permno yq using ../data/dlinfocleaned
drop _merge
merge m:1 permno using ../data/minmaxdate
drop _merge
save alphas_betas_small_f_delist,replace

use ../data/dlinfocleaned, clear
replace yq = yq - 1
rename dlstcd fdlstcd
rename dlret fdlret
save dlinfocleaned_f, replace


use active_sfq_regdata_noalphadrop, clear

drop if f1_qretbenchadjbps == . & f1_4facalphabpsq != .
replace f1_4facalphabpsq = -10000 if f1_4facalphabpsq == .
replace f1_qretbenchadjbps = -10000 if f1_qretbenchadjbps == .

merge m:1 permno yq using ../data/dlinfocleaned
drop if _merge == 2
drop _merge

merge m:1 permno yq using dlinfocleaned_f
drop if _merge == 2
drop _merge

drop if dlstcd != .
replace f1_4facalphabpsq = fdlret*10000 if f1_4facalphabpsq == -10000 & fdlret!=.
replace f1_qretbenchadjbps = (fdlret-tr)*10000 if f1_qretbenchadjbps == -10000 & fdlret!=.

// (1) DROP IF DLSTCT nonmissing in t (they dropped the stock because it delisted)
// (2) replace ret with dlret if dlstcd !=. in t+1
// (3) if dlstcd == . in t+1, then give it a return of -1
drop if f1_qretbenchadjbps == .

capture drop obs
bysort fundno yq: gen obs=_N
drop if obs==1
drop obs

gen wt_cf = shares * abs(adjprc)
replace wt_cf = lsharesvar * abs(adjprc) if dropvar == 1
bysort fundno yq: egen wttot = total(wt_cf)
gen wtfund_cf = wt_cf / wttot
drop wt_cf wttot

* Table 22, filling missing alphas
local a=1
foreach v of varlist f1_4facalphabpsq f1_qretbenchadjbps {
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 noa vce(cluster yq permno fundno)
	if `a' == 1 {
		outreg2 using _regs/sfqreg_missingalphatest, replace bdec(3)
		local a=2
	}
	else{
		outreg2 using _regs/sfqreg_missingalphatest, append bdec(3)
	}
	reghdfe `v' rebalinadja rebalinadjd rebalouta rebaloutd ///
				actshare vwlannturn [aw=wtfund_cf], ///
	 		 	absorb(fundno yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_missingalphatest, append bdec(3)
	reghdfe `v' rebalinadja rebalinadjd  ///
				rebalouta rebaloutd [aw=wtfund_cf], ///
	 		 	absorb(fundno#yq) vce(cluster yq permno fundno)
	outreg2 using _regs/sfqreg_missingalphatest, append bdec(3)
}


